SystemOrganization addCategory: #'MC2-SqueakUI-Tests'!
SystemOrganization addCategory: #'MC2-SqueakUI-Browsers'!
SystemOrganization addCategory: #'MC2-SqueakUI-Nodes'!
SystemOrganization addCategory: #'MC2-SqueakUI-Commands'!
SystemOrganization addCategory: #'MC2-SqueakUI-Panels'!
SystemOrganization addCategory: #'MC2-SqueakUI-Utilities'!

OBCommandTest subclass: #MDCmdAddFileRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2007 13:44'!
edgesForNode: aNode
	^ {OBMetaEdge selector: #repositories}! !

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:57'!
factory
	^ MDCmdAddFileRepository! !

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2007 13:43'!
test04ConditionAcceptsProject
	| node |
	node _ MDProjectNode on: MDProject new.
	node metaNode: self.
	self assert: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdAddMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2007 13:44'!
edgesForNode: aNode
	^ {OBMetaEdge selector: #repositories}! !

!MDCmdAddMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:34'!
factory
	^ MDCmdAddMemoryRepository! !

!MDCmdAddMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2007 13:44'!
test04ConditionAcceptsProject
	| node |
	node _ MDProjectNode on: MDProject new.
	node metaNode: self.
	self assert: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdAddSliceTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2007 13:45'!
edgesForNode: aNode
	^ {OBMetaEdge selector: #slices}! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 22:41'!
factory
	^ MDCmdAddSlice! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2007 13:45'!
test04ConditionAcceptsUnselectedProject
	| node |
	node _ MDProjectNode on: MDProject new.
	node metaNode: self.
	isSelected _ false.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:11'!
test05ConditionRejectsSelectedSlice
	| node |
	node _ MDSliceNode on: (MDExplicitSlice named: '') inProject: MDProject new.
	isSelected _ true.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdChooseVersionTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

MDCmdChooseVersionTest subclass: #MDCmdChooseLocalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdChooseLocalTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 20:14'!
factory
	^ MDCmdChooseLocal! !

!MDCmdChooseLocalTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:20'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $l! !

MDCmdChooseVersionTest subclass: #MDCmdChooseRemoteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdChooseRemoteTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:06'!
factory
	^ MDCmdChooseRemote! !

!MDCmdChooseRemoteTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $r! !

!MDCmdChooseVersionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 18:17'!
isAbstract
	^ self name = #MDCmdChooseVersionTest! !

!MDCmdChooseVersionTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 18:16'!
isSelected: aNode
	^ isSelected! !

!MDCmdChooseVersionTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 18:16'!
test04ConditionAcceptsMergeNode
	| node |
	node _ MDMergeNode on: MDMerge new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdChooseVersionTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 18:16'!
test05ConditionRejectsParent
	| node |
	node _ MDMergeNode on: MDMerge new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdIncludeSnapshotTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:49'!
factory
	^ MDCmdIncludeSnapshot! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:53'!
isSelected: aNode
	^ isSelected! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:51'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $i! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:52'!
test04ConditionAcceptsMemo
	| node |
	node _ MDMemoNode on: MDMemo new inProject: MDProject new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:52'!
test05ConditionIgnoresParent
	| node |
	node _ MDMemoNode on: MDMemo new inProject: MDProject new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdLoadSnapshotTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:01'!
factory
	^ MDCmdLoadSnapshot! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:12'!
isSelected: anObject
	^ isSelected! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:03'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $l! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:09'!
test04ConditionAcceptsMemo
	| node |
	node _ MDMemoNode on: MDMemo new inProject: MDProject new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:11'!
test05ConditionIgnoresParent
	| node |
	node _ MDMemoNode on: MDMemo new inProject: MDProject new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdRemoveRepositoryTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:25'!
factory
	^ MDCmdRemoveRepository! !

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:30'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $x! !

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:27'!
test04ConditionAcceptsRepository
	| node |
	node _ MDRepositoryNode on: MDMemoryRepository new inProject: MDProject new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:29'!
test05ConditionIgnoresParent
	| node |
	node _ MDProjectNode on: MDProject new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdRemoveSliceTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:27'!
factory
	^ MDCmdRemoveSlice! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:31'!
isSelected: anObject
	^ isSelected! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:28'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $x! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:29'!
test04ConditionAcceptsSlice
	| node |
	node _ MDSliceNode on: (MDExplicitSlice named: '') inProject: MDProject new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:32'!
test05ConditionIgnoresParent
	| node |
	node _ MDSliceNode on: (MDExplicitSlice named: '') inProject: MDProject new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdSaveSliceTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:36'!
factory
	^ MDCmdSaveSlice! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:42'!
isSelected: aNode
	^ isSelected! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:39'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $s! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:27'!
test04ConditionAcceptsSlice
	| node |
	node _ MDSliceNode on: MDExplicitSlice new inProject: MDProject new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:29'!
test05ConditionIgnoresParent
	| node |
	node _ MDSliceNode on: MDExplicitSlice new inProject: MDProject new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdSaveSliceToFileTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:45'!
factory
	^ MDCmdSaveSliceToFile! !

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:50'!
isSelected: aNode
	^ isSelected! !

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:30'!
test04ConditionAcceptsSlice
	| node |
	node _ MDSliceNode on: MDExplicitSlice new inProject: MDProject new.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdSaveSliceToFileTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:32'!
test05ConditionIgnoresParent
	| node |
	node _ MDSliceNode on: MDExplicitSlice new inProject: MDProject new.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBBrowser subclass: #MDBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:04'!
defaultBackgroundColor 
	^ (Color r: 0.627 g: 0.69 b: 0.976)! !

MDBrowser subclass: #MDConflictBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDConflictBrowser class methodsFor: 'configuration' stamp: 'cwp 12/9/2007 13:12'!
defaultMetaNode
	| root merge |
	root _ OBMetaNode named: 'inclusion'.
	merge _ OBMetaNode named: 'merge'.
	root - #merges -> merge.
	^ root! !

!MDConflictBrowser class methodsFor: 'opening' stamp: 'cwp 12/9/2007 13:12'!
handleRequest: aRequest
	| root |
	root _ MDInclusionNode 
					workspace: aRequest workingCopy 
					merges: aRequest merges.
	(self root: root) open! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:45'!
localPanel
	^ MDLocalPanel new! !

!MDConflictBrowser class methodsFor: 'configuration' stamp: 'cwp 12/9/2007 10:58'!
paneCount
	^ 1! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:42'!
panels
	^ Array
		with: self navigationPanel
		with: self remotePanel
		with: self localPanel
		with: self resolutionPanel! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:45'!
remotePanel	
	^ MDRemotePanel new! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:46'!
resolutionPanel
	^ MDResolutionPanel new! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 10:58'!
buildOn: aBuilder
	^ aBuilder window: self with: 
		[aBuilder horizontalGroupWith:
			[panels first buildOn: aBuilder.
			panels second buildOn: aBuilder].
		aBuilder horizontalGroupWith:
			[panels third buildOn: aBuilder.
			panels fourth buildOn: aBuilder]]! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:27'!
cmdChooseLocal
	^ MDCmdChooseLocal! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:08'!
cmdChooseRemote
	^ MDCmdChooseRemote! !

MDBrowser subclass: #MDProjectBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 00:46'!
defaultMetaNode
	| project slice repository memo |
	project _ OBMetaNode named: 'project'.
	slice _ OBMetaNode named: 'slice'.
	repository _ OBMetaNode named: 'repository'.
	memo _ OBMetaNode named: 'memo'.
	
	project 
		childAt: #slices put: slice;
		childAt: #repositories put: repository;
		addFilter: OBModalFilter new.
		
	repository childAt: #memos put: memo.
	slice childAt: #memos put: memo.
		
	
	^ project! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 21:39'!
defaultRootNode
	^ MDProjectNode on: MDProject new! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 22:38'!
maxPanes
	^ 2! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:17'!
minPanes
	^ 2! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 21:44'!
openOn: aProject
	^ self openRoot: (MDProjectNode on: aProject)! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:28'!
panels
	^ Array with: self navigationPanel! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:34'!
title
	^ 'Slices'! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:06'!
titleForRoot: aProjectNode
	^ aProjectNode name! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:58'!
cmdAddFileRepository
	^ MDCmdAddFileRepository! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:37'!
cmdAddMemoryRepository
	^ MDCmdAddMemoryRepository ! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:10'!
cmdAddSlice
	^ MDCmdAddSlice! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:54'!
cmdIncludeSnapshot
	^ MDCmdIncludeSnapshot! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:22'!
cmdLoadSnapshot
	^ MDCmdLoadSnapshot! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:32'!
cmdRemoveRepository
	^ MDCmdRemoveRepository! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:33'!
cmdRemoveSlice
	^ MDCmdRemoveSlice! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:00'!
cmdSaveSlice
	^ MDCmdSaveSlice! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:51'!
cmdSaveSliceToFile
	^ MDCmdSaveSliceToFile! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 22:24'!
initialExtent
	^ 400@300! !

OBCommand subclass: #MDCmdAddRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDCmdAddRepository subclass: #MDCmdAddFileRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddFileRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:36'!
createRepository
	| name |
	name _ OBTextRequest prompt: 'Filename?'.
	^ MDFileRepository named: name.
! !

!MDCmdAddFileRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:56'!
label
	^ 'add file repository...'! !

MDCmdAddRepository subclass: #MDCmdAddMemoryRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:37'!
createRepository
	^ MDMemoryRepository new! !

!MDCmdAddMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:34'!
label
	^ 'add memory repository'! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:37'!
execute
	| repository |
	repository _ self createRepository.
	target project store addRepository: repository.
	(MDRepositoryNode on: repository inProject: target project)
		announceCreationWith: requestor! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:50'!
group
	^ #project! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/5/2007 01:14'!
isActive
	^ target isProject and: 
		[(target metaNode edgesForNode: target) anySatisfy: [:ea | ea label = 'repositories']]! !

OBCommand subclass: #MDCmdAddSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:15'!
execute
	| name slice |
	name _ OBTextRequest prompt: 'Enter the name of the slice'.
	slice _ MDPackageInfoSlice named: name.
	target project addSlice: slice.
	(MDSliceNode on: slice inProject: target project) announceCreationWith: requestor! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:12'!
group
	^ #project! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 12/5/2007 01:11'!
isActive
	^ target isProject and: 
		[(target metaNode edgesForNode: target) anySatisfy: [:ea | ea label = 'slices']]! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:52'!
label
	^ 'add slice...'! !

OBCommand subclass: #MDCmdChooseVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDCmdChooseVersion subclass: #MDCmdChooseLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:28'!
execute
	target chooseLocal.
	target announceChangedWith: requestor! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:20'!
keystroke
	^ $l! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 20:14'!
label
	^ 'choose local'! !

MDCmdChooseVersion subclass: #MDCmdChooseRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:09'!
execute
	target chooseRemote.
	target announceChangedWith: requestor! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
keystroke
	^ $r! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
label
	^ 'choose remote'! !

!MDCmdChooseVersion methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:06'!
isActive
	^ target isMerge and: [requestor isSelected: target]! !

OBCommand subclass: #MDCmdIncludeSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:56'!
execute
	target project include: target memo! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:54'!
group
	^ #loading! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:53'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:51'!
keystroke
	^ $i! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:50'!
label
	^ 'include'! !

OBCommand subclass: #MDCmdLoadSnapshot
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:13'!
execute
	target project load: target memo! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:06'!
group
	^ #loading! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:11'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:04'!
keystroke
	^ $l! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:01'!
label
	^ 'load'! !

OBCommand subclass: #MDCmdRemoveRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:31'!
execute
	target project removeRepository: target repository.
	target announceDeletionWith: requestor! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:33'!
group
	^ #repository! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:28'!
isActive
	^ target isRepository! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:30'!
keystroke
	^ $x! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:33'!
label
	^ 'remove'! !

OBCommand subclass: #MDCmdRemoveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:39'!
execute
	target project removeSlice: target slice.
	target announceDeletionWith: requestor! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:34'!
group
	^ #project! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:30'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:28'!
keystroke
	^ $x! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:34'!
label
	^ 'remove slice'! !

OBCommand subclass: #MDCmdSaveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 23:08'!
execute
	| memo |
	memo _ target save.
	(MDMemoNode on: memo inProject: target project)
		announceCreationWith: requestor! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:52'!
group
	^ #saving! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:01'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:37'!
keystroke
	^ $s! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:00'!
label
	^ 'save'! !

OBCommand subclass: #MDCmdSaveSliceToFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 12/3/2007 05:18'!
execute
	| filename |
	filename _ OBTextRequest prompt: 'Filename?'.
	filename ifNotNil: 
		[MDFileRepository
			named: filename
			do: [:repo | target slice saveFrom: target project workspace to: repo]]! !

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:52'!
group
	^ #saving! !

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:48'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdSaveSliceToFile methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:35'!
label
	^ 'save to file...'! !

OBNode subclass: #MDNode
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

MDNode subclass: #MDInclusionNode
	instanceVariableNames: 'workspace merges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDInclusionNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:11'!
workspace: aWorkspace merges: aCollection
	^ self new setWorkspace: aWorkspace merges: aCollection! !

!MDInclusionNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:11'!
merges
	^ merges collect: [:ea | MDMergeNode on: ea]! !

!MDInclusionNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:11'!
setWorkspace: aWorkspace merges: aCollection
	
	workspace _ aWorkspace.
	merges _ aCollection! !

MDNode subclass: #MDMemoNode
	instanceVariableNames: 'memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDMemoNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:13'!
on: aMemo inProject: aProject
	^ self new setMemo: aMemo project: aProject! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
ancestrySelector
	^ #isDescendantOfMemo: ! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
isDescendantOfMemo: aMemoNode
	^ aMemoNode reference = memo reference! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 23:04'!
isDescendantOfSlice: aSliceNode
	^ memo matchesSlice: aSliceNode slice! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:09'!
isMemo
	^ true! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:23'!
memo
	^ memo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 22:37'!
name
	^ memo name! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
reference
	^ memo reference! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:23'!
setMemo: aMemo project: aProject
	project _ aProject.
	memo _ aMemo.! !

MDNode subclass: #MDMergeNode
	instanceVariableNames: 'merge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDMergeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:20'!
on: aMerge
	^ self new setMerge: aMerge! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:26'!
chooseLocal
	^ merge chooseLocal! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:09'!
chooseRemote
	merge chooseRemote! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:20'!
definition
	^ MDPropertiesDefinition new! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:50'!
definitionFrom: aVersion
	^ aVersion 
		ifNotNil: [aVersion variant definition]
		ifNil: [OBDefinition new]! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:23'!
isMerge
	^ true! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:35'!
localDefinition
	^ self definitionFrom: merge local! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:20'!
name
	^ String streamContents: [:s | merge displayOn: s]! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:49'!
remoteDefinition
	^ self definitionFrom: merge remote! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:49'!
resolutionDefinition
	^ self definitionFrom: merge resolution! !

!MDMergeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:20'!
setMerge: aMerge
	merge _ aMerge! !

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:09'!
isMemo
	^ false! !

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:23'!
isMerge
	^ false! !

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 22:52'!
isProject
	^ false! !

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:28'!
isRepository
	^ false! !

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ false! !

!MDNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:02'!
project
	^ project! !

MDNode subclass: #MDProjectNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDProjectNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 21:37'!
on: anOrganizer
	^ self new setProject: anOrganizer! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:19'!
ancestrySelector
	^ #isDescendantOfProject:! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 22:52'!
isProject
	^ true! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:07'!
name
	^ project name! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:11'!
repositories
	^ project repositories collect: [:ea | MDRepositoryNode on: ea inProject: project]! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 21:36'!
setProject: aProject
	project _ aProject! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:34'!
slices
	^ (project slices collect: [:ea | MDSliceNode on: ea inProject: project])
		asArray sort: [:a :b | a name <= b name]! !

MDNode subclass: #MDRepositoryNode
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDRepositoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:10'!
on: aRepository inProject: aProject
	^ self new setRepository: aRepository project: aProject! !

!MDRepositoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:20'!
isDescendantOfProject: aNode
	^ aNode project repositories includes: repository! !

!MDRepositoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:28'!
isRepository
	^ true! !

!MDRepositoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/16/2007 01:28'!
memos
	| memos |
	memos _ repository memos asArray sort.
	^ memos collect: [:ea | MDMemoNode on: ea inProject: project]! !

!MDRepositoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 21:55'!
name
	^ repository description! !

!MDRepositoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:32'!
repository
	^ repository! !

!MDRepositoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:07'!
setRepository: aRepository project: aProject
	project _ aProject.
	repository _ aRepository! !

MDNode subclass: #MDSliceNode
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDSliceNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:33'!
on: aSlice inProject: aProject 
	^ self new setSlice: aSlice project: aProject! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:42'!
ancestrySelector
	^ #isDescendantOfSlice: ! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ true! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/16/2007 01:24'!
memos
	| memos |
	memos _ project store memos select: [:ea | ea matchesSlice: slice].
	memos _ memos asArray sort.
	^ memos collect: [:ea | MDMemoNode on: ea inProject: project]! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 22:21'!
name
	^ slice name! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 21:07'!
save
	^ project save: slice! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 20:33'!
setSlice: aSlice project: aProject
	slice _ aSlice.
	project _ aProject! !

!MDSliceNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 01:01'!
slice
	^ slice! !

!MDDefinitionVariant methodsFor: '*mc2-squeakui' stamp: 'cwp 12/10/2007 19:42'!
definition
	^ MDPropertiesDefinition for: properties! !

!MDRemovalVariant methodsFor: '*mc2-squeakui' stamp: 'cwp 12/10/2007 19:41'!
definition
	^ OBDefinition new! !

OBDefinitionPanel subclass: #MDVersionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

MDVersionPanel subclass: #MDLocalPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

!MDLocalPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:48'!
definitionFrom: aNode
	^ aNode localDefinition! !

MDVersionPanel subclass: #MDRemotePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

!MDRemotePanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:48'!
definitionFrom: aNode
	^ aNode remoteDefinition! !

MDVersionPanel subclass: #MDResolutionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

!MDResolutionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:48'!
definitionFrom: aNode
	^ aNode resolutionDefinition! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 18:08'!
node: aNode
 	node _ aNode.
	node ifNotNil: [self definition: (self definitionFrom: node)]! !

TestCase subclass: #MDNodeAncestryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDNodeAncestryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:09'!
testMemoIdentity
	| memo project a b |
	memo _ MDMemo new.
	project _ MDProject new.
	a _ MDMemoNode on: memo inProject: project.
	b _ MDMemoNode on: memo inProject: project.
	self assert: (a isAncestorOf: b)! !

!MDNodeAncestryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:15'!
testProjectRepository
	| project repository pNode rNode |
	project _ MDSqueakImageProxy createProject.
	repository _ MDMemoryRepository new.
	project addRepository: repository.
	pNode _ MDProjectNode on: project.
	rNode _ MDRepositoryNode on: repository inProject: project.
	self assert: (pNode isAncestorOf: rNode)! !

!MDNodeAncestryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:08'!
testSliceIsAncestor
	| memo project a b slice |
	project _ MDProject new.
	slice _ MDExplicitSlice named: 'test'.
	memo _ MDMemo new.
	memo setSnapshot: (MDSnapshot withVersions: Set new) slice: slice.
	a _ MDSliceNode on: slice inProject: project.
	b _ MDMemoNode on: memo inProject: project.
	self assert: (a isAncestorOf: b)
! !

OBDefinition subclass: #MDPropertiesDefinition
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Utilities'!

!MDPropertiesDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:44'!
for: aPropertyDictionary
	^ self new setProperties: aPropertyDictionary! !

!MDPropertiesDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:43'!
setProperties: aPropertyDictionary
	properties _ aPropertyDictionary! !

!MDPropertiesDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 19:55'!
text
	^ String streamContents:
		[:stream |
		properties keysAndValuesDo: 
			[:k :v |
			stream 
				nextPutAll: k asString;
				nextPut: $:;
				space;
				print: v;
				cr]]! !
